﻿Type=Activity
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private CamperSpinner As Spinner
	Private AmountRadioButton As RadioButton
	Private AmtLabel As Label
	Private BackSpaceButton As Button
	Private ClearButton As Button
	Private AddItemButton As Button
	Private QtyLabel As Label
	Private QtyRadioButton As RadioButton
	Private SaleItemsListView As ListView
	
	Private AmountEnteredString As String
	Private AmountEnteredDouble As Double
	
	Private CamperIDMap As Map
	Private Label1 As Label
	Private ItemTotalLabel As Label
	Private RunningTotalLabel As Label
	
	Private ActiveCamperID As Int
	
	Private SaleState As Int
	Private READYFORSALE As Int
	Private PENDINGSALE As Int
	Private PROCESSINGSALE As Int

	Private CompleteSaleButton As Button
	Private CancelSaleButton As Button
	Private CamperCurrentBalLabel As Label
	Private BalanceOnCompletionLabel As Label
	Private AlternateCamperSpinner As Spinner
	Private AlternateBalanceLabel As Label
	
	Private AltCamperTransButton As Button
	Private DLGAmountEditText As EditText
	Private DLGDepositRadioButton As RadioButton
	Private DLGWithdrawalRadioButton As RadioButton
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("ShopScreen")
	
	Activity.AddMenuItem("Camper Screen","CamperScreen")
	
	AmountEnteredString = ""
	
	AmountRadioButton.Checked = True
	
	CamperIDMap.Initialize
	
	READYFORSALE = 10
	PENDINGSALE = 15
	PROCESSINGSALE = 20
	


End Sub

Sub Activity_Resume
	
	Dim CamperCursor As Cursor
	
	CamperCursor = Main.TuckShopDB.ExecQuery("SELECT * FROM Campers ORDER BY CForename Asc")
	CamperSpinner.Clear
	AlternateCamperSpinner.Clear
	
	
	CamperSpinner.Add("Please Select a Camper")
	CamperIDMap.Put("Please Select a Camper",0)
	
	For i=0 To CamperCursor.RowCount-1
		CamperCursor.Position = i
		
		CamperSpinner.Add( CamperCursor.GetString("CForename") & " " & CamperCursor.GetString("CSurname"))
		AlternateCamperSpinner.Add( CamperCursor.GetString("CForename") & " " & CamperCursor.GetString("CSurname"))
		
		CamperIDMap.Put( CamperCursor.GetString("CForename") & " " & CamperCursor.GetString("CSurname"), CamperCursor.GetInt("CamperID"))
			
	Next 	
	
	CamperSpinner.SelectedIndex = 0	
	SaleItemsListView.Clear
	
	SaleState = READYFORSALE	
	ActiveCamperID = 0
	AmtLabel.Text = "0.00"	
	QtyLabel.Text = "0"	
	
	CheckSaleState
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CamperScreen_Click
	StartActivity(Main)
End Sub

Sub SaleItemsListView_ItemClick (Position As Int, Value As Object)

	Dim RmvResponse As Int
	
	RmvResponse = Msgbox2("Remove Tuck item for amount: £" & NumberFormat2(Value,1,2,2,False),"Remove Tuck","Yes","","No",Null)
	
	If (RmvResponse <> DialogResponse.POSITIVE) Then
		Return	
	End If 
	
	SaleItemsListView.RemoveAt(Position)
	
	CalculateRunningTotal
	UpdateBalanceLabels
	
End Sub

Sub AddItemButton_Click
	
	Dim Amt As Double
	Dim Qty As Double
	Dim LineTotal As Double
	
	If ((AmtLabel.Text <> "") And (QtyLabel.Text <> "0")) Then
		
		Amt = AmtLabel.Text		
		Qty = QtyLabel.Text		
		LineTotal = Amt * Qty
		
		SaleItemsListView.AddTwoLines2("£" & NumberFormat2(LineTotal,1,2,2,False), AmtLabel.Text & " x " & QtyLabel.Text,LineTotal)
		
		AmountEnteredString = ""
		AmountEnteredDouble = 0
		AmtLabel.Text = "0.00"
		
		QtyLabel.Text = "0"		
		
		CalculateLineTotal
		CalculateRunningTotal
		UpdateBalanceLabels
		
	Else
		Msgbox("Either Amt or Qty is missing","Add Item Error")		
	
	End If
	
End Sub

Sub ClearButton_Click
	
	If (AmountRadioButton.Checked) Then
			
		AmountEnteredString = ""
		AmountEnteredDouble = 0
		AmtLabel.Text = "0.00"
	Else
		QtyLabel.Text = "0"	
	
	End If
	
	CalculateLineTotal
		
End Sub

Sub CamperSpinner_ItemClick (Position As Int, Value As Object)
	
	If ((SaleState = READYFORSALE) And (Value <> "Please Select a Camper")) Then
		'create a new sale
		SaleState = PENDINGSALE
		
		ActiveCamperID = CamperIDMap.Get( Value )
		
		CheckSaleState			
	End If	
	
	If (SaleState = PENDINGSALE) Then
		If ((AmtLabel.Text = "0.00") And (QtyLabel.Text = "0")) Then
			ActiveCamperID = CamperIDMap.Get( Value )
		
			CheckSaleState	
		End If
	End If	
	
	UpdateBalanceLabels
	
End Sub

Sub CheckSaleState

	If (SaleState = READYFORSALE) Then
		CamperSpinner.Enabled = True	
		CompleteSaleButton.Enabled = False
		CancelSaleButton.Enabled = False
		AddItemButton.Enabled = False
	End If

	If (SaleState = PENDINGSALE) Then
		
		If ((AmtLabel.Text <> "0.00") Or (QtyLabel.Text <> "0")) Then
			SaleState = PROCESSINGSALE
			
			CamperSpinner.Enabled = False
			CompleteSaleButton.Enabled = True
			CancelSaleButton.Enabled = True
			AddItemButton.Enabled = True
			
		End If	
	End If

End Sub

Sub BackSpaceButton_Click
	
	Dim sf As StringFunctions
	sf.Initialize	
	
	If (AmountRadioButton.Checked) Then
		
		If (sf.Len(AmountEnteredString) > 0) Then
			
			AmountEnteredString = sf.Left(AmountEnteredString, sf.Len(AmountEnteredString)-1)
			
			If (sf.Len(AmountEnteredString) > 0) Then
				
				AmountEnteredDouble = AmountEnteredString / 100

				AmtLabel.Text = NumberFormat2(AmountEnteredDouble,1,2,2,False)		
			Else
				AmountEnteredDouble = 0	
				AmtLabel.Text = "0.00"		
			End If

		End If
	Else
			
		If (sf.Len(QtyLabel.Text) >0) Then
			QtyLabel.Text = sf.Left(QtyLabel.Text, sf.Len(QtyLabel.Text)-1)
			
			If (sf.Len(QtyLabel.Text) =0) Then
				QtyLabel.Text = "0"
			End If			
					
		End If	
	
	End If
	
	CalculateLineTotal
	
End Sub

Sub NumButtonPress_Click
	Dim NumberButton As Button	
	NumberButton = Sender
	
	If (AmountRadioButton.Checked) Then
			
		AmountEnteredString = AmountEnteredString & NumberButton.Text
		
		AmountEnteredDouble = AmountEnteredString / 100
		
		AmtLabel.Text = NumberFormat2(AmountEnteredDouble,1,2,2,False)
	Else
	
		If (QtyLabel.Text = "0") Then
			QtyLabel.Text = NumberButton.Text
		Else
			QtyLabel.Text = QtyLabel.Text & NumberButton.Text	
		End If
		
	End If	
	
	CalculateLineTotal
	
	CheckSaleState	
	
End Sub

Sub CalculateLineTotal

	Dim Amt As Double
	Dim Qty As Double
	
	Dim LineTotal As Double
	
	If (AmtLabel.Text <> "") Then
		
		Amt = AmtLabel.Text
		
		Qty = QtyLabel.Text
		
		LineTotal = Amt * Qty
		
		ItemTotalLabel.Text = "£  " & NumberFormat2(LineTotal,1,2,2,False)		
	
	End If

End Sub

Sub CalculateRunningTotal
	
	Dim RunningTotal As Double
	
	RunningTotal = 0
	
	For i=0 To SaleItemsListView.Size-1
		RunningTotal = RunningTotal + SaleItemsListView.GetItem(i)	
	Next
	
	RunningTotalLabel.Text = "£  " & NumberFormat2(RunningTotal,1,2,2,False)

End Sub


Sub CompleteSaleButton_Click

	CompleteSale	
	
End Sub

Sub CancelSaleButton_Click

	CancelSale	
	
End Sub

Sub CompleteSale
	Dim CompleteResponse As Int
	
	CompleteResponse = Msgbox2("Complete Current Sale?","Sale Confirmation","Yes","","No",Null)
	
	If (CompleteResponse <> DialogResponse.POSITIVE) Then
		Return
	End If
	
	'got here so can complete the sale
	Dim SaleTotal As Double
	SaleTotal = 0
	For i=0 To SaleItemsListView.Size-1
		SaleTotal = SaleTotal + SaleItemsListView.GetItem(i)	
	Next
	
	SaleTotal = SaleTotal * -1
	
	Dim InsSQL As StringBuilder
	Dim TransDate As Long
	
	InsSQL.Initialize
	InsSQL.Append("INSERT INTO Transactions (TransValue, Occurred, TransType, CamperID)").Append(CRLF)
	InsSQL.Append("VALUES (?, ?, ?, ?)")
	
	TransDate = DateTime.Now
	
	Main.TuckShopDB.ExecNonQuery2(InsSQL.ToString, Array As String(SaleTotal, TransDate, "Tuck Sale", ActiveCamperID))

	
	AmountEnteredString = ""
	AmountEnteredDouble = 0
	AmtLabel.Text = "0.00"	
	QtyLabel.Text = "0"	
	
	SaleItemsListView.Clear
	
	ActiveCamperID = 0	
	CamperSpinner.SelectedIndex = 0
	SaleState = READYFORSALE	
	
	CalculateLineTotal
	CalculateRunningTotal
	UpdateBalanceLabels
	CheckSaleState

End Sub

Sub CancelSale 

	Dim CompleteResponse As Int
	
	CompleteResponse = Msgbox2("Cancel Current Sale?","Sale Confirmation","Yes","","No",Null)
	
	If (CompleteResponse <> DialogResponse.POSITIVE) Then
		Return
	End If
	
	'got here so can cancel the sale
	AmountEnteredString = ""
	AmountEnteredDouble = 0
	AmtLabel.Text = "0.00"	
	QtyLabel.Text = "0"	
	
	SaleItemsListView.Clear
	
	ActiveCamperID = 0	
	CamperSpinner.SelectedIndex = 0
	SaleState = READYFORSALE	
	
	CalculateLineTotal
	CalculateRunningTotal
	UpdateBalanceLabels
	CheckSaleState	

End Sub

Sub UpdateBalanceLabels
	If (ActiveCamperID > 0) Then
		Dim BalanceCursor As Cursor
		
		BalanceCursor = Main.TuckShopDB.ExecQuery2("SELECT * FROM CamperBalance WHERE CamperID = ?", Array As String(ActiveCamperID))
		
		BalanceCursor.Position = 0
		
		CamperCurrentBalLabel.Text = "Current Camper Balance: £ " & NumberFormat2(BalanceCursor.GetDouble("CBalance"),1,2,2,False)
		
		Dim AdjBalance As Double
		
		Dim RunningTotal As Double
	
		RunningTotal = 0

		For i=0 To SaleItemsListView.Size-1
			RunningTotal = RunningTotal + SaleItemsListView.GetItem(i)	
		Next
		
		AdjBalance = BalanceCursor.GetDouble("CBalance") - RunningTotal
	
		BalanceOnCompletionLabel.Text = "Balance on Sale Completion: £ " & NumberFormat2(AdjBalance,1,2,2,False)
	Else
		CamperCurrentBalLabel.Text = "Current Camper Balance: £ 0.00"
		BalanceOnCompletionLabel.Text = "Balance on Sale Completion: £ 0.00 "
	End If
End Sub

Sub AlternateCamperSpinner_ItemClick (Position As Int, Value As Object)
	Dim AlternateCamperID As Int
	
	AlternateCamperID = CamperIDMap.Get( Value )
	
	Dim BalanceCursor As Cursor
	BalanceCursor = Main.TuckShopDB.ExecQuery2("SELECT * FROM CamperBalance WHERE CamperID = ?", Array As String(AlternateCamperID))
	
	If (BalanceCursor.RowCount > 0) Then
		BalanceCursor.Position = 0
		AlternateBalanceLabel.Text = "£ " & NumberFormat2(BalanceCursor.GetDouble("CBalance"),1,2,2,False)
	End If
	
End Sub

Sub AltCamperTransButton_Click
	
	Dim AlternateCamperID As Int
	Dim TransDLG As CustomDialog
	Dim TransPanel As Panel
	Dim InsSQL As StringBuilder
	Dim TransDate As Long
	Dim TransDescrip As String
	Dim TransAmt As Double
	
	AlternateCamperID = CamperIDMap.Get( AlternateCamperSpinner.SelectedItem )
	
	If (AlternateCamperID > 0) Then
		
		TransPanel.Initialize("TransPanel")
		TransPanel.LoadLayout("DLGCamperTrans")
		
		
		TransDLG.AddView( TransPanel, 0dip, 0dip, 300dip, 400dip)		
		
		DLGDepositRadioButton.Checked = False
		DLGWithdrawalRadioButton.Checked = True		
		
		
		TransDLG.Show("Add Transaction For: " & AlternateCamperSpinner.SelectedItem,"Ok","Cancel","",Null)
		
		If (TransDLG.Response <> DialogResponse.POSITIVE) Then
			Return
		End If
		
		TransDate = DateTime.Now
		
		If (DLGWithdrawalRadioButton.Checked = True) Then
			TransDescrip = "Withdrawal"
			
			TransAmt = DLGAmountEditText.Text * -1
		Else
			TransDescrip = "Deposit"
			
			TransAmt = DLGAmountEditText.Text
		End If
		
		If (DLGAmountEditText.Text = "") Then
			Return
		End If			
		
		InsSQL.Initialize
		InsSQL.Append("INSERT INTO Transactions (TransValue, Occurred, TransType, CamperID)").Append(CRLF)
		InsSQL.Append("VALUES (?, ?, ?, ?)")		
		
		Main.TuckShopDB.ExecNonQuery2(InsSQL.ToString, Array As String(TransAmt, TransDate, TransDescrip, AlternateCamperID))
		
		Dim BalanceCursor As Cursor
		BalanceCursor = Main.TuckShopDB.ExecQuery2("SELECT * FROM CamperBalance WHERE CamperID = ?", Array As String(AlternateCamperID))
	
		If (BalanceCursor.RowCount > 0) Then
			BalanceCursor.Position = 0
			AlternateBalanceLabel.Text = "£ " & NumberFormat2(BalanceCursor.GetDouble("CBalance"),1,2,2,False)
		End If
	
	Else
		Msgbox("No Alternate Camper Selected - Cannot Perform Transaction","Camper Selection Error")
		Return
	End If	
	
End Sub